
;rotary about arbitrary vector implemented by Maciej Guba
;  ebx - normalized vector 3 dwords, each dword coefficient
;  esi - cosinus and sinus of angle
;  edi - desieres matrix
make_arbitrary_mx:
 .nx	  equ dword[ebx]
 .ny	  equ dword[ebx+4]
 .nz	  equ dword[ebx+8]
 .sinus   equ dword[esi]
 .cosinus equ dword[esi+4]
 fninit
 fld	dword[ebx]
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul	.cosinus ; dword[esi]
 faddp
 fstp	dword[edi]

 fld	.nx
 fmul	.ny
 fld	.cosinus
 fchs
 fld1
 faddp
 fmulp
 fld	.nz ;dword[ebx+8]
 fmul	.sinus	;dword[esi]
; fchs
 faddp
 fstp	dword[edi+4]

 fld	.nx
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.ny
 fmul	.sinus
 fchs
 faddp
 fstp	dword[edi+8]

 fld	.nx
 fmul	.ny
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.sinus
 fmul	.nz
 fchs
 faddp
 fstp	dword[edi+12]

 fld	.ny
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul	.cosinus
 faddp
 fstp	dword[edi+16]

 fld	.ny
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.sinus
 fmul	.nx
; fchs
 faddp
 fstp	dword[edi+20]

 fld	.nx
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.ny
 fmul	.sinus
; fchs
 faddp
 fstp	dword[edi+24]

 fld	.ny
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.nx
 fmul	.sinus
 fchs
 faddp
 fstp	dword[edi+28]

 fld	.nz
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul  .cosinus
 faddp
 fstp  dword[edi+32]
ret




save_object:	   ; make_object - rotate around axis, do points list
		   ; do triangles list and save to 3ds file
   pushad
  .counter equ word [ebp-4]
  .rot_points_ptr equ  dword [ebp-8]
  .one_deg equ dword [ebp-12]
  .steps   equ word  [ebp-16]
   mov	ebp,esp
   sub	esp,64

   mov	esi,Bx1_axis
   mov	edi,Bx2_axis
   mov	ebx,Bx_axis_v
   call make_vector_r
   mov	edi,Bx_axis_v
   call normalize_vector
   xor	eax,eax
   fninit
   fldpi
   fadd  st,st0
   mov	 .steps,BSTEPS
   fidiv .steps
   fstp  .one_deg

   mov	.rot_points_ptr,Bpoints_r      ; points describing rotated solid
 .loop1:

   push  eax
   mov	 ebx,Bx_axis_v
   mov	 edi,Bmatrix
   mov	 .counter,ax	    ; degrees counter
   fld	 .one_deg
   fimul .counter
   fsincos
   fstp  [Bsinus]
   fstp  [Bcosinus]
   lea	 esi,[Bsinus]
   call  make_arbitrary_mx

   mov	 ebx,Bmatrix
   mov	 ecx,BSTEPS   ;[maxcountervar]

   mov	esi,Bpoints
   mov	edi,.rot_points_ptr
   pushad
   call mul_matrix
   popad
   pop	 eax

   add	 .rot_points_ptr,BSTEPS*12
   inc	 eax
   cmp	 eax,BROTARY_STEPS+2
   jne	 .loop1

   ; do triangles list



   mov	 esi,Btriangles

   mov	  edx,BSTEPS-2
   mov	  [Btriangles_count],0	   ; do triangles list
   xor	  ebx,ebx
  .oop2:
   mov	  ecx,BSTEPS-1
  @@:
   mov	  ax,bx
   mov	  [esi],ax
   inc	  ax
   mov	  [esi+8],ax
   mov	  [esi+4],ax
   add	  ax,BSTEPS-1
   mov	  [esi+2],ax
   mov	  [esi+6],ax
   inc	  ax
   mov	  [esi+10],ax
   add	  esi,12
   inc	  bx
   add	  [Btriangles_count],2
   loop   @b
   add	  bx,1

   dec	  dx
   cmp	  dx,0
   jnz	  .oop2



  ;   mov   ax,[maxcountervar]
  ;   int3



   mov	  ecx,(BSTEPS-1) * (BSTEPS-1) - 1
   xor	  ebx,ebx
 @@:
   mov	  eax,ebx
   mov	  [esi],ax
   inc	  ax
   mov	  [esi+2],ax
   mov	  [esi+4],cx
   mov	  [esi+6],cx
   inc	  cx
   mov	  [esi+8],ax
   mov	  [esi+10],cx
   add	  esi,12
   add	  [Btriangles_count],2
   inc	  ebx
   cmp	  ebx,BSTEPS-1
   jne	  @b


   mov	 [esi],dword -1





   mov	 esi,Btriangles
   mov	 edi,triangles
   cld
   mov	 ecx,[Btriangles_count]
;   lea   ecx,[ecx*3]
;   shr   ecx,1
 @@:
   movsd
   movsw
   loop @b
;   rep  movsd
   mov	dword[edi+4],-1


    mov ecx,[global_points_counter] ;MAX_COUNTER*MAX_COUNTER  ;all points count
    mov eax,BROTARY_STEPS-1
    mul ecx
    mov [points_count_var],ax


 ;  mov  [points_count_var],(BSTEPS-1) * (BSTEPS-1) - 1       ;           400

   mov	 esi,Bpoints_r	     ;       [points_count_var]
   mov	 edi,points_r
   movzx ecx,[points_count_var]  ;,(BROTARY_STEPS-1) * (BSTEPS-1) - 1 ;[global_points_counter]
   lea	 ecx,[ecx*3]
   rep	 movsd
   movsd
 ;  mov   dword[edi+4],-1


   mov	ebx, [Btriangles_count]
   mov	[triangles_count_var],bx
;   mov  eax,[global_points_counter]
 ;  mov  [points_count_var],(BROTARY_STEPS-1) * (BSTEPS-1) - 1;ax
;int3


     pushad
    push   dword points_r
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
    call   init_triangles_normals2
    call   init_point_normals
    popad
    call   calc_bumpmap_coords















if 0

    pushad
    mov edi,Bfile_buffer
    mov [edi],word 4d4dh
    add edi,6
    mov [edi],word 3d3dh
    add edi,6
    mov [edi],word 4000h
    add edi,6
    mov [edi],byte 0
    inc edi
    mov [edi],word 4100h     ;    [global_points_counter]
    add  edi,6
    mov [edi],word 4110h
    mov ecx,[global_points_counter] ;MAX_COUNTER*MAX_COUNTER  ;all points count

    mov eax,BROTARY_STEPS-1
    mul ecx
    mov ecx,eax

    mov edx,ecx
    mov [edi+6],cx
    add edi,8
    mov esi,Bpoints_r
    xor ebx,ebx
    lea ecx,[ecx*3]
@@:
    rep movsd
    mov  [edi],word 4120h
    mov  ecx,[Btriangles_count]
    mov  [edi+6],cx
    add  edi,8
    mov  esi,Btriangles
    cld
 @@:
    movsd
    movsw
    add  edi,2
    loop @b



    sub  edi,Bfile_buffer
    mov  [Bfile_buffer+2],edi
    mov  [Bfile_size],edi

    invoke  GetStdHandle, STD_OUTPUT_HANDLE
    mov  [Bfile_handle],eax
    invoke  CreateFile,Bfile_name, GENERIC_WRITE, 0, 0,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    invoke  WriteFile,eax,Bfile_buffer,[Bfile_size],Bbyteswritten, 0
    invoke  CloseHandle,[Bfile_handle]




    popad
end if
    mov   esp,ebp
    popad
ret






